-- at some point I'll go through and tidy this all up properly, it's still pretty messy in places.

import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Extensions";
import "Turbine.UI.Lotro";
import "Turbine.Utils";

FilterBagWindow = class( Turbine.UI.Lotro.Window );

debugging = false;
--OldSearchText = "wazoooo"; -- will use eventually, not right now though.

function echo(yayoutput)
  if debugging then
    Turbine.Shell.WriteLine(yayoutput);
  end
end 

function FilterBagWindow:SetFadeSpeed() --why do i need to define this for Lotro.Window to work?
end

function FilterBagWindow:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self );
	
	sizx = Turbine.PluginData.Load( Turbine.DataScope.Character , "filterbagw") or 300;
	sizy = Turbine.PluginData.Load( Turbine.DataScope.Character , "filterbagh") or 300;
	posx = Turbine.PluginData.Load( Turbine.DataScope.Character , "filterbagx") or  Turbine.UI.Display.GetWidth() - self:GetWidth() - 50;
	posy = Turbine.PluginData.Load( Turbine.DataScope.Character , "filterbagy") or  Turbine.UI.Display.GetHeight() - self:GetHeight() - 50 * 1.5;
	
	self:SetSize(sizx, sizy);
	self:SetBackColor(Turbine.UI.Color());
	self:SetPosition(posx, posy);
	self:SetText( "FilterBag" );

    self.searchInput = Turbine.UI.Lotro.TextBox(); --text box for search term
	self.searchInput:SetParent( self );
	self.searchInput:SetVisible( true );
	self.searchInput:SetPosition(15 , 30);
	self.searchInput:SetSize(300, 20);
	self.searchInput:SetMultiline( false );
	self.searchInput:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	self.searchInput:SetText("");

	-- at some point i'll group these buttons on their own control to make the layout shorter, for now this shall suffice.
	self.searchbutton = Turbine.UI.Lotro.Button(); --search button!
	self.searchbutton:SetParent( self );
	self.searchbutton:SetText( "Search" );
	self.searchbutton:SetPosition( 20, 40 );
	self.searchbutton:SetSize( 60, 20 );
	self.searchbutton.Click = function( sender, args )
		filterBag:Search();
	end
		
	self.sortbutton = Turbine.UI.Lotro.Button(); --sort button!
	self.sortbutton:SetParent( self );
	self.sortbutton:SetText( "Sort" );
	self.sortbutton:SetPosition( 20, 40 );
	self.sortbutton:SetSize( 40, 20 );
	self.sortbutton.Click = function( sender, args )
        self:SortItems();
	end
	
	self.allbutton = Turbine.UI.Lotro.Button(); --clear search button!
	self.allbutton:SetParent( self );
	self.allbutton:SetText( "Show All" );
	self.allbutton:SetPosition( 20, 40 );
	self.allbutton:SetSize( 70, 20 );
	self.allbutton.Click = function( sender, args )
        self.searchInput:SetText("")
		filterBag:Search();
	end

	self:SetWantsKeyEvents( true );

	self.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			sender:SetVisible( false ) 
		end

		if ( args.Action == Turbine.UI.Lotro.Action.ToggleBags or
		     args.Action == Turbine.UI.Lotro.Action.ToggleBag1 or
			 args.Action == Turbine.UI.Lotro.Action.ToggleBag2 or
			 args.Action == Turbine.UI.Lotro.Action.ToggleBag3 or
			 args.Action == Turbine.UI.Lotro.Action.ToggleBag4 or
			 args.Action == Turbine.UI.Lotro.Action.ToggleBag5 )
		then
			sender:SetVisible( not sender:IsVisible() ) 
		end
	end
	
	self.PositionChanged = function(sender, args)
		Turbine.PluginData.Save(Turbine.DataScope.Character , "filterbagx", self:GetLeft());
		Turbine.PluginData.Save(Turbine.DataScope.Character , "filterbagy", self:GetTop());
	end
	
	self.SizeChanged = function(sender, args)
		Turbine.PluginData.Save(Turbine.DataScope.Character , "filterbagw", self:GetWidth());
		Turbine.PluginData.Save(Turbine.DataScope.Character , "filterbagh", self:GetHeight());
	end


	local filterBag = self;
	local mainWindow = self;

	self.itemListBoxScrollBar = Turbine.UI.Lotro.ScrollBar();
	self.itemListBoxScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
	self.itemListBoxScrollBar:SetParent( self );

	self.itemListBox = Turbine.UI.ListBox();
	self.itemListBox:SetParent( self );
	self.itemListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	self.itemListBox:SetVerticalScrollBar( self.itemListBoxScrollBar );
	self.itemListBox:SetAllowDrop( true );
	
	self.itemListBox.DragDrop = function( sender, args )
		local shortcut = args.DragDropInfo:GetShortcut();
		if ( shortcut ~= nil ) then
		  local destinationItemControl = self.itemListBox:GetItemAt( args.X, args.Y );
		  local destinationIndex = self.itemListBox:IndexOfItem( destinationItemControl );
		  self.backpack:PerformShortcutDrop( shortcut, destinationIndex, Turbine.UI.Control.IsShiftKeyDown() );
		end
	end

	self.resizeHandle = Turbine.UI.Control();
	self.resizeHandle:SetParent( self );
	self.resizeHandle:SetZOrder( 100 );
	self.resizeHandle:SetSize(22, 22);
	self.resizeHandle:SetPosition( self:GetWidth() - self.resizeHandle:GetWidth(), self:GetHeight() - self.resizeHandle:GetHeight() );
	--self.resizeHandle:SetBackColor(Turbine.UI.Color());
	self.resizeHandle:SetBackground("Betsiel/FilterBag/resizehandle6.tga");
	self.resizeHandle:SetBlendMode(4);

	self.resizeHandle.MouseDown = function( sender, args )
		sender.dragStartX = args.X;
		sender.dragStartY = args.Y;
		sender.dragging = true;
	end

	self.resizeHandle.MouseMove = function( sender, args )
		local width, height = mainWindow:GetSize();

		if ( sender.dragging ) then
		    local newwidth = width + (args.X - sender.dragStartX);
			local newheight = height + (args.Y - sender.dragStartY);
			if newwidth < 198 then newwidth = 198; end -- any smaller than this and it's unusably small
			if newheight < 198 then newheight = 198; end
			mainWindow:SetSize(newwidth, newheight);
			sender:SetPosition( mainWindow:GetWidth() - sender:GetWidth(), mainWindow:GetHeight() - sender:GetHeight() );
			filterBag:PerformLayout();
		end
	end

	self.resizeHandle.MouseUp = function( sender, args )
		sender.dragging = false;
	end

	-- Initialize the container that holds the elements referencing
	-- the player's inventory.
	self.items = { };

	local player = Turbine.Gameplay.LocalPlayer();
	self.backpack = player:GetBackpack();

	self.backpack.SizeChanged = function( sender, args )
		filterBag:Refresh();
	end

	self.backpack.ItemAdded = function( sender, args )
		filterBag.items[args.Index]:SetItem( filterBag.backpack:GetItem( args.Index ) );
	end

	self.backpack.ItemRemoved = function( sender, args )
		filterBag.items[args.Index]:SetItem( filterBag.backpack:GetItem( args.Index ) );
	end

	self.backpack.ItemMoved = function( sender, args )
		filterBag.items[args.OldIndex]:SetItem( filterBag.backpack:GetItem( args.OldIndex ) );
		filterBag.items[args.NewIndex]:SetItem( filterBag.backpack:GetItem( args.NewIndex ) );
	end

	self:Refresh();
end


function FilterBagWindow:Refresh()
	local backpackSize = self.backpack:GetSize();
	local numitems = 0;
	
	for i = 1, backpackSize, 1 do
		if ( self.items[i] ) then
			self.items[i]:SetParent( nil );
		end
		self.items[i] = Turbine.UI.Lotro.ItemControl( self.backpack:GetItem( i ) );
		self.items[i]:SetBackground("Betsiel/FilterBag/empty2.tga");
		self.itemListBox:AddItem(self.items[i]);
		if self.backpack:GetItem(i) then
		  numitems = numitems + 1;
		else
		  echo(i.." is an empty slot!");
		end
	end
	local backpackSize = self.backpack:GetSize();
	self:SetText("FilterBag ("..numitems.."/"..backpackSize..")");
	self:PerformLayout();
end

function FilterBagWindow:PerformLayout()
	self:Layout( { } )
end

function FilterBagWindow:Layout( args )
	local width, height = self:GetSize();
	
	local itemWidth = 40;
	
	if ( self.items[1] ~= nil ) then
		itemWidth = self.items[1]:GetWidth()
	end
	
	local listWidth = width - 25;
	local listHeight = height - 60;
	local itemsPerRow = listWidth / itemWidth;
	if width > 237 then -- anything smaller than this and the searchbox gets squished too much to use, this code wouold be a lot tidier if i moved the buttons/searchbox onto their own control
	  self:SetText(string.gsub(self:GetText(), "FB", "FilterBag")); --reexpand the title
      self.searchInput:SetSize(listWidth - 185, 20);
      self.searchbutton:SetPosition(listWidth - 165, 31);
      self.allbutton:SetPosition(listWidth - 105, 31);
	  self.sortbutton:SetPosition(listWidth - 35, 31);
    
	  self.itemListBox:SetPosition(10, 50);
	  self.itemListBox:SetSize(listWidth, listHeight);
	  self.itemListBox:SetMaxItemsPerLine(itemsPerRow);
	else -- too small! move everything after the searchbox down a row
	  self:SetText(string.gsub(self:GetText(), "FilterBag", "FB")); --shrink the title so it'll fit better at smaller sizes.
      self.searchInput:SetSize(listWidth - 15, 20);
      self.searchbutton:SetPosition(listWidth - 165, 51);
      self.allbutton:SetPosition(listWidth - 105, 51);
	  self.sortbutton:SetPosition(listWidth - 35, 51);
    
	  self.itemListBox:SetPosition( 5, 70 );
	  self.itemListBox:SetSize(listWidth, listHeight -20);
	  self.itemListBox:SetMaxItemsPerLine(itemsPerRow);
	end
	  
	  
	
   	self.itemListBoxScrollBar:SetPosition( width - 17, 35 );
  	self.itemListBoxScrollBar:SetSize( 10, listHeight );

end


function FilterBagWindow:Search()
    searchString = ""
    if self.searchInput then
      searchString = string.upper(self.searchInput:GetText());
	end
	
	local player = Turbine.Gameplay.LocalPlayer();
	local backpack = player:GetBackpack();
	local backpackSize = backpack:GetSize();
	
	for i = 1, backpackSize, 1 do
		tempItem = backpack:GetItem(i);
  	    if tempItem then
		  itemName = string.upper(tempItem:GetName());
		  if string.find(itemName, searchString) or (searchString == "") then
			self.items[i]:SetVisible(true);
		  else
		    self.items[i]:SetVisible(false);
		  end
		end
	end
end


function FilterBagWindow:SortItems()
	local player = Turbine.Gameplay.LocalPlayer();
	local backpack = player:GetBackpack();
	local backpackSize = backpack:GetSize();
	local itemList = GetOrderedItemList();
	
	local tempItemData = { }
	
	for i = 1, backpackSize, 1 do
	  tempItemData = itemList[i];
	  if tempItemData[2] == "ZZZ" then return; end --last of items!
	  if not (tempItemData[1] == i) then --no point in trying to move something already in the right place...
	    backpack:PerformItemDrop(backpack:GetItem(tempItemData[1]), i, false);
	  end
	end
    self:Search();
end


function GetOrderedItemList()
	local player = Turbine.Gameplay.LocalPlayer();
	local backpack = player:GetBackpack();
	local backpackSize = backpack:GetSize();
	
	local itemList = { }
	local tempItemName = { }
	
	for i = 1, backpackSize, 1 do
		tempItem = backpack:GetItem(i);
  	    if tempItem then
		  tempItemName = { i, string.upper(tempItem:GetName()) };
		  itemList[i] = tempItemName;
		else
		  tempItemName = { i, "ZZZ" };
		  itemList[i] = tempItemName;
		end
		echo("Found at slot "..i..": "..tempItemName[2]);
	end
	table.sort(itemList, compareTempItems);
	return itemList;
end


function compareTempItems(a, b)
  return a[2] < b[2];
end
